Index: trunk/Config.kmk
===================================================================
--- trunk/Config.kmk	(revision 44579)
+++ trunk/Config.kmk	(revision 44580)
@@ -523,6 +523,4 @@
 # Build enhanced version of rdesktop.
 VBOX_WITH_VRDP_RDESKTOP = 1
-# The basic frontend (w/o Main).
-VBOX_WITH_VBOXBFE = 1
 ## The Direct Framebuffer GUI.
 #VBOX_WITH_VBOXFB = 1
@@ -835,5 +833,4 @@
  VBOX_WITH_MAIN =
  VBOX_WITH_VBOXSDL =
- VBOX_WITH_VBOXBFE =
  VBOX_WITH_QTGUI =
  VBOX_WITH_DEBUGGER_GUI =
@@ -849,5 +846,4 @@
  # Permanent (no working SDL).
  VBOX_WITH_VBOXSDL=
- VBOX_WITH_VBOXBFE=
 endif
 
@@ -864,5 +860,4 @@
  # Permanent (no working SDL).
  VBOX_WITH_VBOXSDL=
- VBOX_WITH_VBOXBFE=
  VBOX_WITH_DOCS=
  VBOX_WITH_VBOXDRV=
@@ -947,5 +942,4 @@
  VBOX_WITH_TESTSUITE=
  VBOX_WITH_USB=
- VBOX_WITH_VBOXBFE=
  VBOX_WITH_VBOXDRV=
  VBOX_WITH_VBOXSDL=
@@ -1131,5 +1125,4 @@
  VBOX_WITH_QTGUI=
  VBOX_WITH_VBOXSDL=
- VBOX_WITH_VBOXBFE=
  VBOX_WITH_OGL=
  VBOX_WITH_KCHMVIEWER=
Index: trunk/Makefile.kmk
===================================================================
--- trunk/Makefile.kmk	(revision 44579)
+++ trunk/Makefile.kmk	(revision 44580)
@@ -77,5 +77,5 @@
 # The SDL DLLs
 if1of ($(KBUILD_TARGET), win os2)
- ifneq ($(VBOX_WITH_VBOXSDL)$(VBOX_WITH_VBOXBFE),)
+ ifdef VBOX_WITH_VBOXSDL
   include $(KBUILD_PATH)/sdks/LIBSDL.kmk
   InstallExternalLibs_SOURCES += \
Index: trunk/configure
===================================================================
--- trunk/configure	(revision 44579)
+++ trunk/configure	(revision 44580)
@@ -1261,5 +1261,5 @@
 
 #
-# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
+# Check for the Xcursor library, needed by VBoxSDL.
 #
 check_xcursor()
Index: trunk/src/VBox/Devices/Network/DrvTAP.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/DrvTAP.cpp	(revision 44579)
+++ trunk/src/VBox/Devices/Network/DrvTAP.cpp	(revision 44580)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -902,5 +902,5 @@
      */
     int rc;
-#if defined(RT_OS_SOLARIS)   /** @todo Other platforms' TAP code should be moved here from ConsoleImpl & VBoxBFE. */
+#if defined(RT_OS_SOLARIS)   /** @todo Other platforms' TAP code should be moved here from ConsoleImpl. */
     rc = CFGMR3QueryStringAlloc(pCfg, "TAPSetupApplication", &pThis->pszSetupApplication);
     if (RT_SUCCESS(rc))
Index: trunk/src/VBox/Frontends/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/Makefile.kmk	(revision 44579)
+++ trunk/src/VBox/Frontends/Makefile.kmk	(revision 44580)
@@ -31,8 +31,4 @@
   include $(PATH_SUB_CURRENT)/VBoxSDL/Makefile.kmk
  endif
-# Temporarily disables VBoxBFE as I cannot fix the bustage on a Mac.
-# ifdef VBOX_WITH_VBOXBFE
-#  include $(PATH_SUB_CURRENT)/VBoxBFE/Makefile.kmk
-# endif
  ifdef VBOX_WITH_VBOXFB
   include $(PATH_SUB_CURRENT)/VBoxFB/Makefile.kmk
Index: trunk/src/VBox/HostDrivers/Support/SUPR3HardenedVerify.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPR3HardenedVerify.cpp	(revision 44579)
+++ trunk/src/VBox/HostDrivers/Support/SUPR3HardenedVerify.cpp	(revision 44580)
@@ -185,9 +185,4 @@
     {   kSupIFT_Exe,  kSupID_AppBin,             true, "VBoxSDL" SUPLIB_EXE_SUFF },
     {   kSupIFT_Dll,  kSupID_AppPrivArch,        true, "VBoxSDL" SUPLIB_DLL_SUFF },
-//#endif
-
-//#ifdef VBOX_WITH_VBOXBFE
-    {   kSupIFT_Exe,  kSupID_AppBin,             true, "VBoxBFE" SUPLIB_EXE_SUFF },
-    {   kSupIFT_Dll,  kSupID_AppPrivArch,        true, "VBoxBFE" SUPLIB_DLL_SUFF },
 //#endif
 
Index: trunk/src/VBox/Installer/freebsd/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 44579)
+++ trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 44580)
@@ -203,13 +203,4 @@
 endif
 
-## VBoxBFE - Follow the example set by Windows and Linux.
-#ifdef VBOX_WITH_VBOXBFE
-# VBOX_FBSD_STRIP_BIN += \
-#	VBoxBFE \
-#	$(if $(VBOX_WITH_HARDENING),VBoxBFE.so)
-# VBOX_FBSD_SYMLINKS += \
-#	VBoxBFE
-#endif
-
 # Webservices
 ifdef VBOX_WITH_WEBSERVICES
@@ -323,5 +314,4 @@
 		-e "s;_VBOX_REM_32BIT_MODULE_;$(if $(eq $(KBUILD_TARGET_ARCH),x86),VBoxREM32.so,);g" \
 		-e "s;_VBOX_REM_64BIT_MODULE_;$(if $(eq $(KBUILD_TARGET_ARCH),x86),VBoxREM64.so,);g" \
-		-e "/VBoxBFE/d" \
 		--output $@ \
 		$<
Index: trunk/src/VBox/Installer/freebsd/pkg_plist
===================================================================
--- trunk/src/VBox/Installer/freebsd/pkg_plist	(revision 44579)
+++ trunk/src/VBox/Installer/freebsd/pkg_plist	(revision 44580)
@@ -2,6 +2,4 @@
 @group wheel
 @mode 755
-lib/virtualbox/VBoxBFE
-lib/virtualbox/VBoxBFE.so
 lib/virtualbox/VBoxDbg.so
 lib/virtualbox/VBoxDD.so
@@ -51,5 +49,4 @@
 @mode 755
 bin/VirtualBox
-bin/VBoxBFE
 bin/VBoxManage
 bin/VBoxSVC
Index: trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 44579)
+++ trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 44580)
@@ -297,11 +297,4 @@
 endif
 
-## VBoxBFE - Not shipped on linux due to a typo (VBOX_WITH_BFE), let's keep it that way as it doesn't get enough testing.
-#ifdef VBOX_WITH_VBOXBFE
-# VBOX_LNX_STRIP_BIN += \
-# 	VBoxBFE \
-# 	$(if $(VBOX_WITH_HARDENING),VBoxBFE.so)
-#endif
-
 # Webservices
 ifdef VBOX_WITH_WEBSERVICES
Index: trunk/src/VBox/Installer/linux/VBox.sh
===================================================================
--- trunk/src/VBox/Installer/linux/VBox.sh	(revision 44579)
+++ trunk/src/VBox/Installer/linux/VBox.sh	(revision 44580)
@@ -113,7 +113,4 @@
         run_in_group "$INSTALL_DIR/vboxwebsrv" "$@"
         ;;
-    VBoxBFE|vboxbfe)
-        run_in_group "$INSTALL_DIR/VBoxBFE" "$@"
-        ;;
     *)
         echo "Unknown application - $APP"
Index: trunk/src/VBox/Installer/linux/debian/VBox.sh
===================================================================
--- trunk/src/VBox/Installer/linux/debian/VBox.sh	(revision 44579)
+++ trunk/src/VBox/Installer/linux/debian/VBox.sh	(revision 44580)
@@ -92,7 +92,4 @@
         exec "$INSTALL_DIR/vboxwebsrv" "$@"
         ;;
-    VBoxBFE|vboxbfe)
-        exec "$INSTALL_DIR/VBoxBFE" "$@"
-        ;;
     *)
         echo "Unknown application - $APP"
Index: trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 44579)
+++ trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 44580)
@@ -215,7 +215,4 @@
 	VBoxXPCOMIPCD \
 	$(if $(VBOX_WITH_KCHMVIEWER),kchmviewer,)
-## Follow the Windows + Linux example of not shipping VBoxBFE.
-#SOLARIS_STRIP_EXES = \
-#	$(if $(VBOX_WITH_VBOXBFE),VBoxBFE,)
 
 SOLARIS_DRIVER_BINS = \
@@ -274,7 +271,4 @@
 	$(if $(VBOX_WITH_VBOXSDL),VBoxSDL.so,) \
 	$(if $(VBOX_WITH_QTGUI),VirtualBox.so,)
-## Follow the Windows + Linux example of not shipping VBoxBFE.
-#SOLARIS_STRIP_BINS += \
-#	$(if $(VBOX_WITH_VBOXBFE),VBoxBFE.so,)
 endif
 
Index: trunk/src/VBox/Installer/solaris/VBox.sh
===================================================================
--- trunk/src/VBox/Installer/solaris/VBox.sh	(revision 44579)
+++ trunk/src/VBox/Installer/solaris/VBox.sh	(revision 44580)
@@ -44,7 +44,4 @@
         exec "$INSTALL_DIR/vboxwebsrv" "$@"
         ;;
-    VBoxBFE|vboxbfe)
-        exec "$INSTALL_DIR/VBoxBFE" "$@"
-        ;;
     VBoxQtconfig)
         exec "$INSTALL_DIR/VBoxQtconfig" "$@"
Index: trunk/src/VBox/Installer/solaris/makepackage.sh
===================================================================
--- trunk/src/VBox/Installer/solaris/makepackage.sh	(revision 44579)
+++ trunk/src/VBox/Installer/solaris/makepackage.sh	(revision 44580)
@@ -126,7 +126,4 @@
     ln -f ./VBoxISAExec $VBOX_INSTALLED_DIR/VirtualBox
 fi
-if test -f $VBOX_INSTALLED_DIR/amd64/VBoxBFE || test -f $VBOX_INSTALLED_DIR/i386/VBoxBFE; then
-    ln -f ./VBoxISAExec $VBOX_INSTALLED_DIR/VBoxBFE
-fi
 if test -f $VBOX_INSTALLED_DIR/amd64/VBoxHeadless || test -f $VBOX_INSTALLED_DIR/i386/VBoxHeadless; then
     ln -f ./VBoxISAExec $VBOX_INSTALLED_DIR/VBoxHeadless
@@ -194,10 +191,8 @@
             ||  $3 == "opt/VirtualBox/amd64/VBoxHeadless" \
             ||  $3 == "opt/VirtualBox/amd64/VBoxSDL" \
-            ||  $3 == "opt/VirtualBox/amd64/VBoxBFE" \
             ||  $3 == "opt/VirtualBox/i386/VirtualBox" \
             ||  $3 == "opt/VirtualBox/i386/VirtualBox3" \
             ||  $3 == "opt/VirtualBox/i386/VBoxHeadless" \
             ||  $3 == "opt/VirtualBox/i386/VBoxSDL" \
-            ||  $3 == "opt/VirtualBox/i386/VBoxBFE" \
             ) \
        { $4 = "4755" } { print }' prototype > prototype2
Index: trunk/src/VBox/Main/include/MouseImpl.h
===================================================================
--- trunk/src/VBox/Main/include/MouseImpl.h	(revision 44579)
+++ trunk/src/VBox/Main/include/MouseImpl.h	(revision 44580)
@@ -22,7 +22,5 @@
 #include "ConsoleEvents.h"
 #include "ConsoleImpl.h"
-#ifndef VBOXBFE_WITHOUT_COM
 #include "EventImpl.h"
-#endif
 #include <VBox/vmm/pdmdrv.h>
 
@@ -34,7 +32,5 @@
 class ATL_NO_VTABLE Mouse :
     public VirtualBoxBase
-#ifndef VBOXBFE_WITHOUT_COM
     , VBOX_SCRIPTABLE_IMPL(IMouse)
-#endif
 {
 public:
@@ -69,7 +65,5 @@
     STDMETHOD(PutMouseEventAbsolute)(LONG x, LONG y, LONG dz, LONG dw,
                                      LONG buttonState);
-#ifndef VBOXBFE_WITHOUT_COM
     STDMETHOD(COMGETTER(EventSource)) (IEventSource ** aEventSource);
-#endif
 
     static const PDMDRVREG  DrvReg;
@@ -114,9 +108,5 @@
     bool supportsRel(void);
 
-#ifdef VBOXBFE_WITHOUT_COM
-    Console *mParent;
-#else
     Console * const         mParent;
-#endif
     /** Pointer to the associated mouse driver. */
     struct DRVMAINMOUSE    *mpDrv[MOUSE_MAX_DEVICES];
@@ -127,29 +117,9 @@
     uint32_t mfLastButtons;
 
-#ifndef VBOXBFE_WITHOUT_COM
     const ComObjPtr<EventSource> mEventSource;
     VBoxEventDesc                mMouseEvent;
 
     void fireMouseEvent(bool fAbsolute, LONG x, LONG y, LONG dz, LONG dw, LONG Buttons);
-#else
-    void fireMouseEvent(bool fAbsolute, LONG x, LONG y, LONG dz, LONG dw, LONG Buttons)
-    {}
-#endif
 };
-
-#ifdef VBOXBFE_WITHOUT_COM
-/** @todo make this a member of Console */
-extern Mouse *gMouse;
-
-/** @todo can we get these from the API somehow? */
-enum
-{
-    MouseButtonState_LeftButton = 1,
-    MouseButtonState_RightButton = 2,
-    MouseButtonState_MiddleButton = 4,
-    MouseButtonState_XButton1 = 8,
-    MouseButtonState_XButton2 = 16
-};
-#endif
 
 #endif // !____H_MOUSEIMPL
Index: trunk/src/VBox/Main/src-client/MouseImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/MouseImpl.cpp	(revision 44579)
+++ trunk/src/VBox/Main/src-client/MouseImpl.cpp	(revision 44580)
@@ -110,5 +110,4 @@
     unconst(mParent) = parent;
 
-#ifndef VBOXBFE_WITHOUT_COM
     unconst(mEventSource).createObject();
     HRESULT rc = mEventSource->init(static_cast<IMouse*>(this));
@@ -116,5 +115,4 @@
     mMouseEvent.init(mEventSource, VBoxEventType_OnGuestMouse,
                      0, 0, 0, 0, 0);
-#endif
 
     /* Confirm a successful initialization */
@@ -144,11 +142,7 @@
     }
 
-#ifdef VBOXBFE_WITHOUT_COM
-    mParent = NULL;
-#else
     mMouseEvent.uninit();
     unconst(mEventSource).setNull();
     unconst(mParent) = NULL;
-#endif
 }
 
@@ -256,5 +250,4 @@
 }
 
-#ifndef VBOXBFE_WITHOUT_COM
 STDMETHODIMP Mouse::COMGETTER(EventSource)(IEventSource ** aEventSource)
 {
@@ -269,5 +262,4 @@
     return S_OK;
 }
-#endif
 
 /**
@@ -413,5 +405,4 @@
 }
 
-#ifndef VBOXBFE_WITHOUT_COM
 void Mouse::fireMouseEvent(bool fAbsolute, LONG x, LONG y, LONG dz, LONG dw, LONG Buttons)
 {
@@ -430,5 +421,4 @@
     }
 }
-#endif
 
 