Index: trunk/doc/manual/fr_FR/user_Security.xml
===================================================================
--- trunk/doc/manual/fr_FR/user_Security.xml	(revision 43080)
+++ trunk/doc/manual/fr_FR/user_Security.xml	(revision 44638)
@@ -3,79 +3,85 @@
 "http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd">
 <chapter id="Security">
-  <title>Security guide</title>
+  <title>Guide de sécurité</title>
 
   <sect1>
-    <title>Overview</title>
-    <para>
-    </para>
-
-    <sect2>
-      <title>General Security Principles</title>
-
-      <para>The following principles are fundamental to using any application
-        securely.
+    <title>Aperçu</title>
+    <para>
+    </para>
+
+    <sect2>
+      <title>Principes généraux de sécurité</title>
+
+      <para>Les principes suivants sont fondamentaux pour utiliser une application
+        en toute sécurité.
         <glosslist>
           <glossentry>
-            <glossterm>Keep Software Up To Date</glossterm>
-            <glossdef>
-              <para>
-                One of the principles of good security practise is to keep all
-                software versions and patches up to date. Activate the VirtualBox
-                update notification to get notified when a new VirtualBox release
-                is available. When updating VirtualBox, do not forget to update
-                the Guest Additions. Keep the host operating system as well as the
-                guest operating system up to date.
-              </para>
-            </glossdef>
-          </glossentry>
-
-          <glossentry>
-            <glossterm>Restrict Network Access to Critical Services</glossterm>
-            <glossdef>
-              <para>
-                Use proper means, for instance a firewall, to protect your computer
-                and your guest(s) from accesses from the outside. Choosing the proper
-                networking mode for VMs helps to separate host networking from the
-                guest and vice versa.
-              </para>
-            </glossdef>
-          </glossentry>
-
-          <glossentry>
-            <glossterm>Follow the Principle of Least Privilege</glossterm>
-            <glossdef>
-              <para>
-                The principle of least privilege states that users should be given the
-                least amount of privilege necessary to perform their jobs. Always execute VirtualBox
-                as a regular user. We strongly discourage anyone from executing
-                VirtualBox with system privileges.
-              </para>
-              <para>
-                Choose restrictive permissions when creating configuration files,
-                for instance when creating /etc/default/virtualbox, see
-                <xref linkend="linux_install_opts"/>. Mode 0600 would be preferred.
-              </para>
-            </glossdef>
-          </glossentry>
-
-          <glossentry>
-            <glossterm>Monitor System Activity</glossterm>
-            <glossdef>
-              <para>
-                System security builds on three pillars: good security protocols, proper
-                system configuration and system monitoring. Auditing and reviewing audit
-                records address the third requirement. Each component within a system
-                has some degree of monitoring capability. Follow audit advice in this
-                document and regularly monitor audit records.
-              </para>
-            </glossdef>
-          </glossentry>
-
-          <glossentry>
-            <glossterm>Keep Up To Date on Latest Security Information</glossterm>
-            <glossdef>
-              <para>
-                Oracle continually improves its software and documentation. Check this
-                note note yearly for revisions.
+            <glossterm>Maintenir à jour le logiciel</glossterm>
+            <glossdef>
+              <para>
+                Une des bonnes pratirues de sécurité est d'avoir des versioos du
+                logiciel et des correctifs à jour. Activez la notification de
+                mise à jour de VirtualBox pour être averti quand une nouvelle
+                version de VirtualBox est disponible. Quand vous mettez à jour
+                VirtualBox, n'oubliez pas de mett!e à jour aussi les suppléments
+                invité. Maintenez à jour le système d'exploitation hôte ainsi
+                que l'invité.
+              </para>
+            </glossdef>
+          </glossentry>
+
+          <glossentry>
+            <glossterm>Restriindre l'accès réseau des services critiques</glossterm>
+            <glossdef>
+              <para>
+                Utilisez les moyens, tels qu'un pare-feu, pour protéger votre
+                ordinateur et vo(s) invité(s) de l'extérieur. Choisir le bon mode
+                de réseau pour des VMs permet de distinguer le réseau de l'hôte
+                de l'invité et vice versa.
+              </para>
+            </glossdef>
+          </glossentry>
+
+          <glossentry>
+            <glossterm>Suivre le principe du privilège le plus restreint</glossterm>
+            <glossdef>
+              <para>
+                Le principe du privilège le plus restreint dispose qu'il faut
+                donner aux utilisateurs les privilèges strictement nécessaires
+                pour accomplir leurs tâches. Exécutez toujours VirtualBox en
+                tant qu'utilisateur ordinaire. Nous déconseillons fortement
+                d'exécuter VirtualBox avec des privilèges système.
+              </para>
+              <para>
+                Choisissez des droits restrictifs quand vous créez des fichiers
+                de configuration, par exemple quand vous créez
+                /etc/default/virtualbox, voir
+                <xref linkend="linux_install_opts"/>. Le mode 0600 serait
+                idéal. 
+              </para>
+            </glossdef>
+          </glossentry>
+
+          <glossentry>
+            <glossterm>Surveiller l'activité du szstème</glossterm>
+            <glossdef>
+              <para>
+                La sécurité du système repose sur trois piliers&#xA0;: de bons
+                protocoles de sécurité, une bonne configuration du système et
+                la surveillance du szstème. L'évaluation et la lecture des
+                fruits de l'évaluation constituent la troisième exigence. Chaque
+                composant d'un système a un certain degré de capacité à être
+                surveillé. Suivez les conseils d'évaluation de ce document et
+                surveillez régulièrement les fruits de l'évaluation.
+              </para>
+            </glossdef>
+          </glossentry>
+
+          <glossentry>
+            <glossterm>Garder à jour les informations de sécurité</glossterm>
+            <glossdef>
+              <para>
+                Oracle améliore en permanence ses logiciels et sa documentation.
+                Vérifiez ce passage chaque année pour truurer les révisions.
               </para>
             </glossdef>
@@ -88,160 +94,167 @@
 
   <sect1>
-    <title>Secure Installation and Configuration</title>
+    <title>Installation et configuration sécurisées</title>
   </sect1>
 
   <sect2>
-    <title>Installation Overview</title>
-    <para>
-      The VirtualBox base package should be downloaded only from a trusted source,
-      for instance the official website
+    <title>Aperçu de l'installation</title>
+    <para>
+      Vous ne devriez télécharger le paquet de base de VirtualBox qu'à partir d'une
+      source de confiance, telle que le site Internet officiel 
       <ulink url="http://www.virtualbox.org">http://www.virtualbox.org</ulink>.
-      The integrity of the package should be verified with the provided SHA256
-      checksum which can be found on the official website.
-    </para>
-    <para>
-      General VirtualBox installation instructions for the supported hosts
-      can be found in <xref linkend="installation"/>.
-    </para>
-    <para>
-      On Windows hosts, the installer allows for disabling USB support, support
-      for bridged networking, support for host-only networking and the Python
-      language bindings, see <xref linkend="installation_windows"/>.
-      All these features are enabled by default but disabling some
-      of them could be appropriate if the corresponding functionality is not
-      required by any virtual machine. The Python language bindings are only
-      required if the VirtualBox API is to be used by external Python
-      applications. In particular USB support and support
-      for the two networking modes require the installation of Windows kernel
-      drivers on the host. Therefore disabling those selected features can
-      not only be used to restrict the user to certain functionality but
-      also to minimize the surface provided to a potential attacker.     </para>
-    <para>
-      The general case is to install the complete VirtualBox package. The
-      installation must be done with system privileges. All VirtualBox binaries
-      should be executed as a regular user and never as a privileged user.
-    </para>
-    <para>
-      The Oracle VM VirtualBox extension pack provides additional features
-      and must be downloaded and installed separately, see
-      <xref linkend="intro-installing"/>. As for the base package, the SHA256
-      checksum of the extension pack should be verified. As the installation
-      requires system privileges, VirtualBox will ask for the system
-      password during the installation of the extension pack.
+      Vous devriez vérifier l'intégrité du paquet avec la somme de contrôle 
+      SHA256 fournie sur le site officiel.
+    </para>
+    <para>
+      Vous pouvez trouver des instructions générales d'installation de VirtualBox
+      pour les hôtes supportés au <xref linkend="installation"/>.
+    </para>
+    <para>
+      Sur les hôtes Windows, l'installeur permet de désactiver le support USB,
+      le support du réseau bridgé, le support du réseau host-only et les bindings
+      du langage Python, voir <xref linkend="installation_windows"/>. Toutes ces
+      fonctionnalités sont activées par défaut mais la désactivation de certaines
+      d'entre elles pourrait être adaptée si vous n'avez pas besoin des
+      fonctionnalités correspondantes sur une machine virtuelle. Les bindings du
+      langage Python ne sont nécessaires que si vous devez utiliser l'API de
+      VirtualBox avec des applications Python externes. En particulier, le
+      support USB et le support des deux modes réseaux nécessitent d'installer
+      des pilotes du noyau Windows sur l'hôte. Donc, la désactivation de ces
+      fonctions peut non seulement permettre d'encadrer l'utilisateur dans
+      certaines fonctionnalités, mais aussi de minimiser le champ d'attaque d'un
+      pirate potentiel.</para>
+    <para>
+      En général, on installe tout le paquet VirtualBox. Il faut faire
+      l'installation avec les privilèges système. Tous les binaires de VirtualBox
+      devraient être lancés en tant qu'utilisateur ordinaire et jamais en tant
+      qu'utilisateur privilégié.
+    </para>
+    <para>
+      Le pack d'extension d'Oracle VM VirtualBox apporte des fonctionnalités
+      supplémentaires et il doit être téléchargé et installé à part, voir
+      <xref linkend="intro-installing"/>. Comme pour le paquet de base, vous devriez vérifier
+      la somme de contrôle SHA256 du pack d'extension. Comme le système d'installation
+      exige des privilèges systèmes, VirtualBox vous demandera le mot de passe
+      système pendant l'installation du pack d'extension.
     </para>
   </sect2>
 
   <sect2>
-    <title>Post Installation Configuration</title>
-    <para>
-      Normally there is no post installation configuration of VirtualBox components
-      required. However, on Solaris and Linux hosts it is necessary to configure
-      the proper permissions for users executing VMs and who should be able to
-      access certain host resources. For instance, Linux users must be member of
-      the <emphasis>vboxusers</emphasis> group to be able to pass USB devices to a
-      guest. If a serial host interface should be accessed from a VM, the proper
-      permissions must be granted to the user to be able to access that device.
-      The same applies to other resources like raw partitions, DVD/CD drives
-      and sound devices.
+    <title>Configuration post installation</title>
+    <para>
+      Normalement, aucune configuration post installation d'un composant de
+      VirtualBox n'est nécessaire. Cependant, sur les hôtes Solaris et Linux,
+      il faut configurer les droits adaptés pour que les utilisateurs exécutent
+      des VMs et puissent accéder à certaines ressources de l'hôte. Par exemple,
+      les utilisateurs Linux doivent faire partie du groupe <emphasis>vboxusers</emphasis> 
+      pour pouvoir donner des périphériques USB à un invité. Si vous devriez
+      accéder à une interface série à partir d'une VM, il faut donner les bons
+      droits à l'utilisateur pour qu'il puisse accéder à ce périphérique. La
+      même chose s'applique à d'autres ressources comme la partition brute, les
+      lecteurs DVD/CD et les périphériques de son.
     </para>
   </sect2>
 
   <sect1>
-    <title>Security Features</title>
-    <para>This section outlines the specific security mechanisms offered
-      by VirtualBox.</para>
-
-    <sect2>
-      <title>The Security Model</title>
+    <title>Fonctions de sécurité</title>
+    <para>Cette section évoque les mécanismes de sécurité spécifiques à
+     VirtualBox.</para>
+
+    <sect2>
+      <title>Le modèle de sécurité</title>
       <para>
-        One property of virtual machine monitors (VMMs) like VirtualBox is to encapsulate
-        a guest by executing it in a protected environment, a virtual machine,
-        running as a user process on the host operating system. The guest cannot
-        communicate directly with the hardware or other computers but only through
-        the VMM. The VMM provides emulated physical resources and devices to the
-        guest which are accessed by the guest operating system to perform the required
-        tasks. The VM settings control the resources provided to the guest, for example
-        the amount of guest memory or the number of guest processors, (see
-        <xref linkend="generalsettings"/>) and the enabled features for that guest
-        (for example remote control, certain screen settings and others).
+        Une des propriétés des gestionnaires de machines virtuels (VMMs) comme 
+        VirtualBox est d'enfermer un invité en l'exécutant dans un environnement
+        protégé, une machine virtuelle laquelle fonctionne en tant que processus
+        d'un utilisateur du système d'exploitation hôte. L'invité ne peut pas
+        communiquer directement avec le matériel hôte ou avec d'autres ordinateurs,
+        mais uniquement via le VMM. Le VMM offre des ressources physiques et des
+        périphériques émulés à l'invité, auxquelles on accède par le système d'exploitation hôte pour effectuer les
+        tâches nécessaires. Les paramètres de la VM contrôlent les ressources 
+        fournies à l'invité, par exemple la quantité de mémoire de l'invité ou
+        le nombre de processeurs invités (voir <xref linkend="generalsettings"/>) 
+        et les fonctionnalités activées pour cet invité (par exemple le contrôle à distance, certains paramètres
+        d'affichage et autres).
       </para>
     </sect2>
     
     <sect2>
-      <title>Secure Configuration of Virtual Machines</title>
+      <title>Configuration pécurisée des machines virtuelles</title>
       <para>
-        Several aspects of a virtual machine configuration are subject to security
-        considerations.</para>
-
-      <sect3>
-        <title>Networking</title>
-        <para>
-          The default networking mode for VMs is NAT which means that
-          the VM acts like a computer behind a router, see
-          <xref linkend="network_nat"/>. The guest is part of a private
-          subnet belonging to this VM and the guest IP is not visible
-          from the outside. This networking mode works without
-          any additional setup and is sufficient for many purposes.
-        </para>
-        <para>
-          If bridged networking is used, the VM acts like a computer inside
-          the same network as the host, see <xref linkend="network_bridged"/>.
-          In this case, the guest has the same network access as the host and
-          a firewall might be necessary to protect other computers on the
-          subnet from a potential malicious guest as well as to protect the
-          guest from a direct access from other computers. In some cases it is
-          worth considering using a forwarding rule for a specific port in NAT
-          mode instead of using bridged networking.
-        </para>
-        <para>
-          Some setups do not require a VM to be connected to the public network
-          at all. Internal networking (see <xref linkend="network_internal"/>)
-          or host-only networking (see <xref linkend="network_hostonly"/>)
-          are often sufficient to connect VMs among each other or to connect
-          VMs only with the host but not with the public network.
-        </para>
-      </sect3>
-
-      <sect3>
-        <title>VRDP remote desktop authentication</title>
-        <para>When using the VirtualBox extension pack provided by Oracle
-          for VRDP remote desktop support, you can optionally use various
-          methods to configure RDP authentication. The "null" method is
-          very insecure and should be avoided in a public network.
-          See <xref linkend="vbox-auth" /> for details.</para>
+        Plusieurs aspects de la configuration d'une machine virtuelle sont sujets
+        à des considérations de sécurité.</para>
+
+      <sect3>
+        <title>Le réseau</title>
+        <para>
+          Le mode réseau par défaut des VMs est NAT, ce qui signifie que la VM
+          se comporte comme un ordinateur derrière un routeur, voir
+          <xref linkend="network_nat"/>. L'invité fait partie d'un sous-réseau
+          privé appartenant à cette VM et l'adresse IP de l'invité n'est pas visible
+          de l'extérieur. Ce mode réseau fonctionne sans paramétrage supplémentaire
+          et il suffit pour la plupart des besoins. 
+        </para>
+        <para>
+          Si vous utilisé le réseau bridgé, la VM se comporte comme un ordinateur
+          dans le même réseau que l'hôte, voir <xref linkend="network_bridged"/>.
+          Dans ce cas, l'invité a un accès réseau identique à l'hôte et un
+          pare-feu pourrait être nécessaire pour protéger d'autres ordinateurs
+          du sous-réseau contre des invités malveillants potentiels et pour
+          protéger l'invité contre un accès direct par les autres ordinateurs.
+          Dans certains cas, il est intçressant de songer à utiliser une règle
+          de redirection pour un port spécifique en mode NAT, plutôt que d'utiliser
+          le réseau bridgé.
+        </para>
+        <para>
+          Certaines configurations n'ont pas besoin que la VM soit connectée au
+          réseau public. Le réseau interne (voir <xref linkend="network_internal"/>)
+          ou le réseau host-only (voir <xref linkend="network_hostonly"/>) suffisent
+          souvent pour connecter des VMs entre elles ou pour ne connecter des VMs
+          qu'à l'hôte mais pas au réseau public.
+        </para>
+      </sect3>
+
+      <sect3>
+        <title>Authentification sur un bureau distant (VRDP)</title>
+        <para>Quand on utilise le pack d'extension de VirtualBox fourni par Oracle
+        pour accéder à distance (VRDP), on peut éventuellement utiliser
+        plusieurs méthodes pour configurer l'authentification RDP. La méthode
+        "null" est très peu sûre, vous devriez l'éviter sur un réseau public.
+          Voir <xref linkend="vbox-auth" /> pour les détails.</para>
       </sect3>
 
       <sect3 id="security_clipboard">
-        <title>Clipboard</title>
-        <para>
-          The shared clipboard allows users to share data between the host and
-          the guest. Enabling the clipboard in "Bidirectional" mode allows
-          the guest to read and write the host clipboard. The "Host to guest"
-          mode and the "Guest to host" mode limit the access to one
-          direction. If the guest is able to access the host clipboard it
-          can also potentially access sensitive data from the host which is
-          shared over the clipboard.
-        </para>
-        <para>
-          If the guest is able to read from and/or write to the host clipboard
-          then a remote user connecting to the guest over the network will also
-          gain this ability, which may not be desirable. As a consequence, the
-          shared clipboard is disabled for new machines.
-        </para>
-      </sect3>
-
-      <sect3>
-        <title>Shared folders</title>
-        <para>If any host folder is shared with the guest then a remote
-          user connected to the guest over the network can access
-          these files too as the folder sharing mechanism cannot be
-          selectively disabled for remote users.
-        </para>
-      </sect3>
-
-      <sect3>
-        <title>3D graphics acceleration</title>
-        <para>Enabling 3D graphics via the Guest Additions exposes the host
-          to additional security risks; see <xref
+        <title>Presse-papier</title>
+        <para>
+          Le presse-papier partagé permet aux utilisateurs de partager des
+          données entre l'hôte et l'invité. L'activation du presse-papier en
+          "mode bidirectionnel" permet à l'invité de lire et d'écrire dans le
+          presse-papier de l'hôte. Le mode "hôte vers invité" et "Invité vers
+          hôte" limitent l'accès à un seul sens. Si l'invité peut accéder au
+          presse-papier de l'hôte, il peut aussi accéder potentiellement à des
+          données sensibles de l'hôte partagées dans le presse-papier.
+        </para>
+        <para>
+          Si l'invité peut lire et/ou écrire dans le presse-papier de l'hôte,
+          un utilisateur distant qui se connecte à l'invité par le réseau aura
+          également cette possibilité, ce qui peut ne pas être souhaitable. Par
+          conséquent, le presse-papier partagé est désactivé pour les nouvelles
+          machines.
+        </para>
+      </sect3>
+
+      <sect3>
+        <title>Dossiers partagés</title>
+        <para>Si un dossier de l'hôte est partagé avec l'invité, n'importe quel utilisateur
+        connecté à distance à l'invité par le réseau peut accéder aussi à ces
+        fichiers car le mécanisme de partage des dossiers ne peut pas être désactivé
+        de manière sélective pour des utilisateurs distants.
+        </para>
+      </sect3>
+
+      <sect3>
+        <title>Accélération graphique 3D</title>
+        <para>L'activation de la 3D avec les suppléments invité expose l'hôte
+        à des risques supplémentaires de sécurité&#xA0;; voir <xref
           linkend="guestadd-3d" />.</para>
       </sect3>
@@ -249,8 +262,8 @@
       <sect3>
         <title>CD/DVD passthrough</title>
-        <para>Enabling CD/DVD passthrough allows the guest to perform advanced
-          operations on the CD/DVD drive, see <xref linkend="storage-cds"/>.
-          This could induce a security risk as a guest could overwrite data
-          on a CD/DVD medium.
+        <para>L'activation du CD/DVD passthrough permet à l'invité d'effectuer
+        des opérations avancées sur le lecteur CD/DVD, voir <xref linkend="storage-cds"/>.
+          Cela peut poser un problème de sécurité car un invité pourrait écraser
+          des données sur un DVD.
         </para>
       </sect3>
@@ -259,39 +272,40 @@
         <title>USB passthrough</title>
         <para>
-          Passing USB devices to the guest provides the guest full access
-          to these devices, see <xref linkend="settings-usb"/>. For instance,
-          in addition to reading and writing the content of the partitions
-          of an external USB disk the guest will be also able to read and
-          write the partition table and hardware data of that disk.
-        </para>
-      </sect3>
-
-    </sect2>
-
-    <sect2>
-      <title>Configuring and Using Authentication</title>
-
-      <para>The following components of VirtualBox can use passwords for
-        authentication:<itemizedlist>
-
-        <listitem>
-          <para>When using remote iSCSI storage and the storage server
-          requires authentication, an initiator secret can optionally be supplied
-          with the <computeroutput>VBoxManage storageattach</computeroutput>
-          command. As long as no settings password is provided (command line
-          option <screen>--settingspwfile</screen>, this secret is
-          stored <emphasis role="bold">unencrypted</emphasis> in the machine
-          configuration and is therefore potentially readable on the host.
-          See <xref
-          linkend="storage-iscsi" /> and <xref
+          La présentation de périphériques USB à l'invité offre à l'invité un
+          accès complet à ces périphériques, voir <xref linkend="settings-usb"/>.
+          Par exemple, outre la lecture et l'écriture du contenu des partitionpartitions
+          d'un disque USB externe, l'invité pourra également lire et écrire la
+          table de partitions et des données matérielles sur ce disque.
+        </para>
+      </sect3>
+
+    </sect2>
+
+    <sect2>
+      <title>Configurer et utiliser l'authentification</title>
+
+      <para>Les composants suivants de VirtualBox peuvent utiliser des mots de
+      passe pour l'authentification&#xA0;:<itemizedlist>
+
+        <listitem>
+          <para>Lors de l'utilisation du stockage iSCSI à distance et si le
+          serveur de stockage exige une authentification, vous pouvez fournir
+          un mot de passe d'initiateur avec la commande
+          <computeroutput>VBoxManage storageattach</computeroutput>. Tant que
+          vous ne fournissez pas de réglage de mots de passe (l'option
+          <screen>--settingspwfile</screen> en ligne de commande), ce mot
+          de passe secret est stocké <emphasis role="bold">sans chiffrement</emphasis> 
+          dans la configuration de la machine et il est donc potentiellement
+          lisible sur l'hôte. Voir <xref
+          linkend="storage-iscsi" /> et <xref
           linkend="vboxmanage-storageattach" />.</para>
         </listitem>
 
         <listitem>
-          <para>When using the VirtualBox web service to control a VirtualBox
-          host remotely, connections to the web service are authenticated in
-          various ways. This is described in detail in the VirtualBox Software
-          Development Kit (SDK) reference; please see <xref
-          linkend="VirtualBoxAPI" />.</para>
+          <para>Quand vous utilisez le service Web de VirtualBox pour contrôler
+          un hôte VirtualBox à distance, les connexions au service sont authentifiées
+          de plusieurs façons. Ceci est décrit en détails dans manuel de référence
+          du kit de développement logiciel de VirtualBox (SDK)&#xA0;; merci de
+          voir <xref linkend="VirtualBoxAPI" />.</para>
         </listitem>
       </itemizedlist></para>
@@ -300,56 +314,59 @@
     <!--
     <sect2>
-      <title>Configuring and Using Access Control</title>
-    </sect2>
-
-    <sect2>
-      <title>Configuring and Using Security Audit</title>
-    </sect2>
-
-    <sect2>
-      <title>Congiguring and Using Other Security Features</title>
+      <title>Configurer et utiliser les contrôles d'accès</title>
+    </sect2>
+
+    <sect2>
+      <title>Configurer et utiliser l'évaluation de sécurité</title>
+    </sect2>
+
+    <sect2>
+      <title>Congigurer et utiliser d'autres fonctions de sécurité</title>
     </sect2>
     -->
 
     <sect2>
-    <title>Potentially insecure operations</title>
-
-      <para>The following features of VirtualBox can present security
-        problems:<itemizedlist>
-        <listitem>
-          <para>Enabling 3D graphics via the Guest Additions exposes the host
-          to additional security risks; see <xref
+    <title>Opçrations potentiellement non sécurisées</title>
+
+      <para>Les fonctions suivantes de VirtualBox peuvent présenter des problèmes
+      de sécurité&#xA0;:<itemizedlist>
+        <listitem>
+          <para>L'activation de la 3D par les suppléments invité expose l'hôte
+          à des risques de sécurité supplémentaires&#xA0;; voir <xref
           linkend="guestadd-3d" />.</para>
         </listitem>
 
         <listitem>
-          <para>When teleporting a machine, the data stream through which the
-          machine's memory contents are transferred from one host to another
-          is not encrypted. A third party with access to the network through
-          which the data is transferred could therefore intercept that
-          data. An SSH tunnel could be used to secure the connection between
-          the two hosts. But when considering teleporting a VM over an untrusted
-          network the first question to answer is how both VMs can securely
-          access the same virtual disk image(s) with a reasonable performance. </para>
-        </listitem>
-
-        <listitem>
-          <para>When using the VirtualBox web service to control a VirtualBox
-          host remotely, connections to the web service (through which the API
-          calls are transferred via SOAP XML) are not encrypted, but use plain
-          HTTP by default. This is a potential security risk! For details about
-          the web service, please see <xref linkend="VirtualBoxAPI" />.</para>
-          <para>The web services are not started by default. Please refer to
-          <xref linkend="vboxwebsrv-daemon"/> to find out how to start this
-          service and how to enable SSL/TLS support. It has to be started as
-          a regular user and only the VMs of that user can be controled. By
-          default, the service binds to localhost preventing any remote connection.</para>
+          <para>En téléportant une machine, le flux de données par lequel passe
+          le contenu de la mémoire de la machine est transféré d'un hô!e à l'autre
+          sans chiffrement. Un tiers ayant un accès au réseau par lequel les
+          données sont transférées pourrait donc intercepter ces données. On
+          pourrait utiliser un tunnel SSH pour sécuriser la connexion entre les
+          deux hôtes. Mais au moment de téléporter une VM par un réseau non fiable,
+          la première question à vous poser est celle de savoir comment les VMs
+          peuvent accéder de manière sécurisée à la/aux même(s) image(s) de disque
+          virtuel avec une performance raisonnable. </para>
+        </listitem>
+
+        <listitem>
+          <para>Quand vous utilisez le service Web de VirtualBox pour contrôler
+          un hôte VirtualBox à distance, les connexions au service (par lesquelles
+          les appels de l'API sont transférées en SOAP XML) ne sont pas chiffrées,
+          elles utilisent par défaut le HTTP en clair. C'est un risque potentiel
+          de sécurité&#xA0;! Pour des détails sur le service Web, merci de voir
+          <xref linkend="VirtualBoxAPI" />.</para>
+          <para>Les services web ne sont pas lancés par défaut. Merci de vous
+          reporter au <xref linkend="vboxwebsrv-daemon"/> pour voir comment
+          démarrer ce service et activer le support SSL/TLS. Il faut le démarrer
+          en tant qu'utilisateur ordinaire et seules les VMs de cet utilisateur
+          sont contrôlables. Par défaut, le service sonde localhost, empêchant
+          toute connexion distante.</para>
         </listitem>
         
         <listitem>
-          <para>Traffic sent over a UDP Tunnel network attachment is not
-          encrypted. You can either encrypt it on the host network level (with
-          IPsec), or use encrypted protocols in the guest network (such as
-          SSH). The security properties are similar to bridged Ethernet.</para>
+          <para>Le trafic envoyé par une connexion réseau en tunnel UDP n'est
+          pas chiffré. Vous pouvez soit le chiffrer au niveau du réseau hôte 
+          (avec IPsec), soit utiliser des protocoles chiffrés dans le réseau 
+          invité (tel que SSH). The security properties are similar to bridged Ethernet.</para>
         </listitem>
       </itemizedlist></para>
@@ -357,15 +374,15 @@
 
     <sect2>
-      <title>Encryption</title>
-
-      <para>The following components of VirtualBox use encryption to protect
-        sensitive data:<itemizedlist>
-        <listitem>
-          <para>When using the VirtualBox extension pack provided by Oracle
-          for VRDP remote desktop support, RDP data can optionally be
-          encrypted. See <xref linkend="vrde-crypt" /> for details. Only
-          the Enhanced RDP Security method (RDP5.2) with TLS protocol
-          provides a secure connection. Standard RDP Security (RDP4 and
-          RDP5.1) is vulnerable to a man-in-the-middle attack.</para>
+      <title>Chiffrement</title>
+
+      <para>Les composants suivants de VirtualBox utilisent le chiffrement pour
+      protéger ces données sensibles&#xA0;:<itemizedlist>
+        <listitem>
+          <para>Quand on utilise le pack d'extension de VirtualBox fourni par
+          Oracle pour le support du bureau distant (VRDP), les données peuvent
+          être éventuellement chiffrées. Voir <xref linkend="vrde-crypt" /> pour
+          des détails. Seule la méthode Enhanced RDP Security (RDP5.2) avec le
+          protocole TLS offre une connexion sécurisée. La Standard RDP Security
+          (RDP4 et RDP5.1) est vulnérable à une attaque man-in-the-middle.</para>
         </listitem>
       </itemizedlist></para>